set terminal postscript eps color "Arial" 12
set key out horiz right top
set size 0.5, 0.5
set pointsize 1
set output "sa-speed-phi.eps"
set xlabel "Phi (log scale)"
set ylabel "Updates/ms"
set log x
set xrange [0.0001:0.01]
set style line 1 lt -1 lw 1 pt 1
set style line 2 lt 1 lw 1 pt 1
set style line 3 lt -1 lw 1 pt 2
set style line 4 lt 1 lw 1 pt 2
set style line 5 lt -1 lw 1 pt 4
set style line 6 lt 1 lw 1 pt 4
set style line 7 lt -1 lw 1 pt 6
set style line 8 lt 1 lw 1 pt 6
set style line 9 lt -1 lw 1 pt 5
set style line 10 lt 1 lw 1 pt 5
set style line 11 lt -1 lw 1 pt 3
set style line 12 lt 1 lw 1 pt 3
set style line 13 lt -1 lw 1 pt 7
set style line 14 lt 1 lw 1 pt 7
set style line 15 lt -1 lw 1 pt 8
set style line 16 lt 1 lw 1 pt 8
set style line 17 lt -1 lw 1 pt 9
set style line 18 lt 1 lw 1 pt 9

plot	"zipf.CCFC-1.0-4.speedvsphi" with linespoints title "CS" ls 1, \
	"zipf.CMH-1.0-4.speedvsphi" with linespoints title "CMH" ls 3, \
	"zipf.CGT-1.0-4.speedvsphi" with linespoints title "CGT" ls 5
